#property copyright "IgorM"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_width1 2
#property indicator_color2 Yellow
#property indicator_width2 1
#property indicator_style2 1
#property indicator_color3 Lime
#property indicator_width3 1
#property indicator_style3 2

//
//
//
//
//

extern string TimeFrame             = "Current time frame";
extern int    short_term_SMA_period = 20;
extern int    long_term_EMA_period  = 40;      
extern bool   use_eursek            = false;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   
   SetIndexBuffer(0,Buffer1); SetIndexLabel(0,"EURX");
   SetIndexBuffer(1,Buffer2); SetIndexLabel(1,short_term_SMA_period+"SMA");
   SetIndexBuffer(2,Buffer3); SetIndexLabel(2, long_term_EMA_period+"EMA"); 
   
    //
    //
    //
    //
    //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
    //
    //
    //
    //
    //
     
   IndicatorShortName(timeFrameToString(timeFrame)+"    EUR_Index_SMA_EMA: EURX / "+short_term_SMA_period+"SMA / "+long_term_EMA_period+"EMA");
}

//
//
//
//
//

int deinit() {  return(0); }

//
//
//
//
//

int start()
{
   int    pointModifier;
   int    counted_bars = IndicatorCounted();
   int    i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Buffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   { 

   for(i=limit; i>=0; i--) if(use_eursek) { Buffer1[i] = 34.38805726 * MathPow(iClose("EURUSD",0,i),0.3155) *  
                                                                       MathPow(iClose("EURGBP",0,i),0.3056) * 
                                                                       MathPow(iClose("EURJPY",0,i),0.1891) * 
                                                                       MathPow(iClose("EURCHF",0,i),0.1113) * 
                                                                       MathPow(iClose("EURSEK",0,i),0.0785); }
                                    else  { Buffer1[i] = 34.38805726 * MathPow(iClose("EURUSD",0,i),0.3155) *  
                                                                       MathPow(iClose("EURGBP",0,i),0.3056) * 
                                                                       MathPow(iClose("EURJPY",0,i),0.1891) * 
                                                                       MathPow(iClose("EURCHF",0,i),0.1113); } 
   
   for(i=limit; i>=0; i--)
   {
      Buffer2[i]=0;
      Buffer3[i]=0;
      
      for(int z = 0; z < short_term_SMA_period; z++) { Buffer2[i] = Buffer2[i]+Buffer1[i+z]; }
          
      Buffer2[i] = Buffer2[i]/short_term_SMA_period;
      if(Buffer1[i] > 0)
      Buffer3[i] = Buffer1[i]*(2.0/(long_term_EMA_period+1))+Buffer3[i+1]*(1-(2.0/(long_term_EMA_period+1)));   
   }
   return(0);
   }
   
   //
   //
   //
   //
   //
  
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
          Buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",short_term_SMA_period,long_term_EMA_period,0,y);
          Buffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",short_term_SMA_period,long_term_EMA_period,1,y);
          Buffer3[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",short_term_SMA_period,long_term_EMA_period,2,y);
          
            
    }
return(0);
}

//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

